﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WPFAndWinFrom
{
   public partial class Form2 : Form
   {
      public Form2()
      {
         InitializeComponent();
         _control = txtText;
      }

      Control _control;

      private void FrmMain_Load(object sender, EventArgs e)
      {
         var propData = this.GetType().GetProperties().Where(prop => 
            prop.PropertyType == typeof(string) || prop.PropertyType == typeof(bool) || prop.PropertyType.IsEnum).ToArray();
         cbxProperty.DataSource = propData;
         cbxProperty.DisplayMember = "Name";
         cbxProperty.ValueMember = "PropertyType";
      }

      private void cbxProperty_SelectedIndexChanged(object sender, EventArgs e)
      {
         Control con = null;
         PropertyInfo prop = cbxProperty.SelectedItem as PropertyInfo;

         if (prop.PropertyType.IsEnum)
         {
            ComboBox cbx = new ComboBox();
            cbx.DropDownStyle = ComboBoxStyle.DropDownList;
            cbx.DataSource = Enum.GetValues(prop.PropertyType);

            cbx.SelectedIndex = -1;
            cbx.SelectedIndexChanged += (s, arg) =>
               this.GetType().GetProperty(cbxProperty.Text).SetValue(this, cbx.SelectedItem);

            con = cbx;
         }
         else if (prop.PropertyType == typeof(bool))
         {
            CheckBox chbx = new CheckBox();
            chbx.Text = prop.Name;
            chbx.Checked = (bool)prop.GetValue(this);

            chbx.CheckedChanged += (s, arg) =>
               this.GetType().GetProperty(cbxProperty.Text).SetValue(this, chbx.Checked);

            con = chbx;
         }
         else
         {
            TextBox txt = new TextBox();
            txt.TextChanged += (s, arg) =>
               this.GetType().GetProperty(cbxProperty.Text).SetValue(this, txt.Text);

            con = txt;
         }

         con.Width = _control.Width;
         con.Location = _control.Location;
         con.Anchor = _control.Anchor;

         this.Controls.Remove(_control);

         _control = con;
         this.Controls.Add(_control);
      }
   }
}
